/* m_services.c - Script generated services commands definition file
** Customized for BCNet
** Copyright Jeremy Johnston (c) 2004
** Based upon services.pl, W. Campbell (c) 2003-2004
** Do not edit this file

** Built from parse.inc.php:  and index.php: 
*/

#include "stdinc.h"
#include "handlers.h"
#include "client.h"
#include "common.h"
#include "ircd.h"
#include "irc_string.h"
#include "numeric.h"
#include "fdlist.h"
#include "s_bsd.h"
#include "s_conf.h"
#include "s_log.h"
#include "s_serv.h"
#include "send.h"
#include "msg.h"
#include "parse.h"
#include "modules.h"

#define SVS_nickserv_NICK "NickServ"
#define SVS_nickserv_USERSERV "NickServ@services.blackcode.com"
#define SVS_chanserv_NICK "ChanServ"
#define SVS_chanserv_USERSERV "ChanServ@services.blackcode.com"
#define SVS_hellserv_NICK "HellServ"
#define SVS_hellserv_USERSERV "HellServ@services.blackcode.com"
#define SVS_gameserv_NICK "GameServ"
#define SVS_gameserv_USERSERV "GameServ@bcnet.gameserv"
#define SVS_statsserv_NICK "StatServ"
#define SVS_statsserv_USERSERV "StatServ@services.blackcode.com"

char *reconstruct_parv(int parc, char *parv[]);

static void m_nickserv(struct Client *client_p, struct Client *source_p, int parc, char *parv[]);
static void m_chanserv(struct Client *client_p, struct Client *source_p, int parc, char *parv[]);
static void m_hellserv(struct Client *client_p, struct Client *source_p, int parc, char *parv[]);
static void m_gameserv(struct Client *client_p, struct Client *source_p, int parc, char *parv[]);
static void m_statsserv(struct Client *client_p, struct Client *source_p, int parc, char *parv[]);

struct Message nickserv_msgtab = {
  "nickserv", 0, 0, 2, 0, MFLG_SLOW, 0,
  {m_unregistered, m_nickserv, m_ignore, m_nickserv}
};

struct Message ns_msgtab = {
  "ns", 0, 0, 2, 0, MFLG_SLOW, 0,
  {m_unregistered, m_nickserv, m_ignore, m_nickserv}
};

struct Message chanserv_msgtab = {
  "chanserv", 0, 0, 2, 0, MFLG_SLOW, 0,
  {m_unregistered, m_chanserv, m_ignore, m_chanserv}
};

struct Message cs_msgtab = {
  "cs", 0, 0, 2, 0, MFLG_SLOW, 0,
  {m_unregistered, m_chanserv, m_ignore, m_chanserv}
};

struct Message hellserv_msgtab = {
  "hellserv", 0, 0, 2, 0, MFLG_SLOW, 0,
  {m_unregistered, m_hellserv, m_ignore, m_hellserv}
};

struct Message hs_msgtab = {
  "hs", 0, 0, 2, 0, MFLG_SLOW, 0,
  {m_unregistered, m_hellserv, m_ignore, m_hellserv}
};

struct Message gameserv_msgtab = {
  "gameserv", 0, 0, 2, 0, MFLG_SLOW, 0,
  {m_unregistered, m_gameserv, m_ignore, m_gameserv}
};

struct Message gs_msgtab = {
  "gs", 0, 0, 2, 0, MFLG_SLOW, 0,
  {m_unregistered, m_gameserv, m_ignore, m_gameserv}
};

struct Message statsserv_msgtab = {
  "statsserv", 0, 0, 2, 0, MFLG_SLOW, 0,
  {m_unregistered, m_statsserv, m_ignore, m_statsserv}
};

struct Message ss_msgtab = {
  "ss", 0, 0, 2, 0, MFLG_SLOW, 0,
  {m_unregistered, m_statsserv, m_ignore, m_statsserv}
};

#ifndef STATIC_MODULES
void _modinit(void)
{
  mod_add_cmd(&nickserv_msgtab);
  mod_add_cmd(&ns_msgtab);
  mod_add_cmd(&chanserv_msgtab);
  mod_add_cmd(&cs_msgtab);
  mod_add_cmd(&hellserv_msgtab);
  mod_add_cmd(&hs_msgtab);
  mod_add_cmd(&gameserv_msgtab);
  mod_add_cmd(&gs_msgtab);
  mod_add_cmd(&statsserv_msgtab);
  mod_add_cmd(&ss_msgtab);
}

void _moddeinit(void)
{
  mod_del_cmd(&nickserv_msgtab);
  mod_del_cmd(&ns_msgtab);
  mod_del_cmd(&chanserv_msgtab);
  mod_del_cmd(&cs_msgtab);
  mod_del_cmd(&hellserv_msgtab);
  mod_del_cmd(&hs_msgtab);
  mod_del_cmd(&gameserv_msgtab);
  mod_del_cmd(&gs_msgtab);
  mod_del_cmd(&statsserv_msgtab);
  mod_del_cmd(&ss_msgtab);
}
const char *_version = "$Revision: 1.16 $";
#endif

char *reconstruct_parv(int parc, char *parv[])
{
  static char tmpbuf[BUFSIZE]; int i;

  strlcpy (tmpbuf, parv[0], BUFSIZE);
  for (i = 1; i < parc; i++)
  {
    strlcat (tmpbuf, " ", BUFSIZE);
    strlcat (tmpbuf, parv[i], BUFSIZE);
  }
  return tmpbuf;
}

static void m_nickserv(struct Client *client_p, struct Client *source_p, int parc, char *parv[])
{
  struct Client *target_p;

  if (parv[1] == NULL)
  {
    sendto_one(source_p, form_str(ERR_NOTEXTTOSEND), me.name, source_p->name);
    return;
  }

if ((target_p = find_person(SVS_nickserv_NICK)))
  {
    sendto_one(target_p, ":%s PRIVMSG %s :%s", parv[0], SVS_nickserv_USERSERV, reconstruct_parv(parc - 1, &parv[1]));
  }
  else
    sendto_one(source_p, form_str(ERR_NOSUCHNICK), me.name, parv[0], SVS_nickserv_NICK);
}

static void m_chanserv(struct Client *client_p, struct Client *source_p, int parc, char *parv[])
{
  struct Client *target_p;

  if (parv[1] == NULL)
  {
    sendto_one(source_p, form_str(ERR_NOTEXTTOSEND), me.name, source_p->name);
    return;
  }

if ((target_p = find_person(SVS_chanserv_NICK)))
  {
    sendto_one(target_p, ":%s PRIVMSG %s :%s", parv[0], SVS_chanserv_USERSERV, reconstruct_parv(parc - 1, &parv[1]));
  }
  else
    sendto_one(source_p, form_str(ERR_NOSUCHNICK), me.name, parv[0], SVS_chanserv_NICK);
}

static void m_hellserv(struct Client *client_p, struct Client *source_p, int parc, char *parv[])
{
  struct Client *target_p;

  if (parv[1] == NULL)
  {
    sendto_one(source_p, form_str(ERR_NOTEXTTOSEND), me.name, source_p->name);
    return;
  }

if ((target_p = find_person(SVS_hellserv_NICK)))
  {
    sendto_one(target_p, ":%s PRIVMSG %s :%s", parv[0], SVS_hellserv_USERSERV, reconstruct_parv(parc - 1, &parv[1]));
  }
  else
    sendto_one(source_p, form_str(ERR_NOSUCHNICK), me.name, parv[0], SVS_hellserv_NICK);
}

static void m_gameserv(struct Client *client_p, struct Client *source_p, int parc, char *parv[])
{
  struct Client *target_p;

  if (parv[1] == NULL)
  {
    sendto_one(source_p, form_str(ERR_NOTEXTTOSEND), me.name, source_p->name);
    return;
  }

if ((target_p = find_person(SVS_gameserv_NICK)))
  {
    sendto_one(target_p, ":%s PRIVMSG %s :%s", parv[0], SVS_gameserv_USERSERV, reconstruct_parv(parc - 1, &parv[1]));
  }
  else
    sendto_one(source_p, form_str(ERR_NOSUCHNICK), me.name, parv[0], SVS_gameserv_NICK);
}

static void m_statsserv(struct Client *client_p, struct Client *source_p, int parc, char *parv[])
{
  struct Client *target_p;

  if (parv[1] == NULL)
  {
    sendto_one(source_p, form_str(ERR_NOTEXTTOSEND), me.name, source_p->name);
    return;
  }

if ((target_p = find_person(SVS_statsserv_NICK)))
  {
    sendto_one(target_p, ":%s PRIVMSG %s :%s", parv[0], SVS_statsserv_USERSERV, reconstruct_parv(parc - 1, &parv[1]));
  }
  else
    sendto_one(source_p, form_str(ERR_NOSUCHNICK), me.name, parv[0], SVS_statsserv_NICK);
}

